Attribute VB_Name = "modPCScript"
Public ScriptRunner As ScriptControl
Public ScriptCode As String
Public ScriptMembers As New Collection

Public Sub InitScriptTree(Filename As String, ByRef TV As TreeView)

'Remark: Meaning of dtt symbols

'~      Global object
'!        Provided object
'@     Sub head of children of objects
' '       Child of Global object
'2      Child of Provided object
'-       IHTMLElement
'=      IHTMLElementCollection

    Dim t As Integer
    t = FreeFile
    
    Open Filename For Input As #t
        
        Dim TopCount As Integer
        Dim SecondCount As Integer
        Dim ChildCount As Integer
        Dim SubCount As Integer
        Dim SubChildCount As Integer
        Dim GlobalSecondCount As Integer
        Dim GlobalChildCount As Integer
        
        Dim a As String
        
        Do Until EOF(t)
        
        Line Input #t, a
        
        If IsNumeric(Left(a, 1)) = False Then 'Special Node
        
            Select Case Left(a, 1)
            
                Case "~"
                    
                    TopCount = TopCount + 1
                    
                    TV.Nodes.Add , , "glo", Mid(a, 2, InStr(2, a, ":") - 2), "global"
                    TV.Nodes("glo").Expanded = True
                    ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "glo"
            
                Case "!" 'A top level object
                    
                    TopCount = TopCount + 1
                    
                    TV.Nodes.Add , , "top" & TopCount, Mid(a, 2, InStr(2, a, ":") - 2), "object"
                    TV.Nodes("top" & TopCount).Expanded = True
                    ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "top" & TopCount
                                        
                Case "@" 'A second level mother
                
                    SecondCount = SecondCount + 1
                    
                    TV.Nodes.Add "top" & TopCount, 4, "sec" & SecondCount, Mid(a, 2, InStr(2, a, ":") - 2), Mid(a, 2, InStr(2, a, ":") - 2)

                    ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "sec" & SecondCount
                
                Case "#" 'A second level mother of Global
                    
                    GlobalSecondCount = GlobalSecondCount + 1
                    
                    TV.Nodes.Add "glo", 4, "globalmethods" & GlobalSecondCount, Mid(a, 2, InStr(2, a, ":") - 2), "Methods"
                    
                    TV.Nodes("globalmethods" & GlobalSecondCount).Expanded = True
                    
                    ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "globalmethods" & GlobalSecondCount
                
                Case "'" 'A member of Global Methods
                    
                    GlobalChildCount = GlobalChildCount + 1
                    
                    TV.Nodes.Add "globalmethods" & GlobalSecondCount, 4, "gbm" & GlobalChildCount, Mid(a, 2, InStr(2, a, ":") - 2), "Methods"
                    
                    ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "gbm" & GlobalChildCount
                
            End Select
            
        Else
                ChildCount = ChildCount + 1
                
                Select Case Mid(a, 2, 1)
                    
                    Case "-" 'IHTMLElement
                        
                        TV.Nodes.Add "sec" & SecondCount, 4, "chd" & ChildCount, Mid(a, 3, InStr(2, a, ":") - 3), TV.Nodes("sec" & SecondCount).text
                    
                        ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "chd" & ChildCount

                        Dim t1 As Integer, B As String
                        t1 = FreeFile
                        Open App.Path & "\info\ScriptIHTMLElement.dtt" For Input As #t1
                        Do Until EOF(t1)
                        Line Input #t1, B
                        Select Case Left(B, 1)
                        Case "@"
                        SubCount = SubCount + 1
                        TV.Nodes.Add "chd" & ChildCount, 4, "sub" & SubCount, Mid(B, 2, InStr(2, B, ":") - 2), Mid(B, 2, InStr(2, B, ":") - 2)
                        ScriptMembers.Add Mid(B, InStr(2, B, ":") + 1), "sub" & SubCount
                        Case "3"
                        SubChildCount = SubChildCount + 1
                        TV.Nodes.Add "sub" & SubCount, 4, "sbc" & SubChildCount, Mid(B, 2, InStr(2, B, ":") - 2), TV.Nodes("sub" & SubCount).text
                        ScriptMembers.Add Mid(B, InStr(2, B, ":") + 1), "sbc" & SubChildCount
                        End Select
                        Loop
                        Close #t1
                        
                    Case "=" 'IHTMLElementCollection
                        
                        TV.Nodes.Add "sec" & SecondCount, 4, "chd" & ChildCount, Mid(a, 3, InStr(2, a, ":") - 3), TV.Nodes("sec" & SecondCount).text
                    
                        ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "chd" & ChildCount

                        Dim t2 As Integer, c As String
                        t2 = FreeFile
                        Open App.Path & "\info\ScriptIHTMLElementCollection.dtt" For Input As #t2
                        Do Until EOF(t2)
                        Line Input #t1, c
                        Select Case Left(c, 1)
                        Case "@"
                        SubCount = SubCount + 1
                        TV.Nodes.Add "chd" & ChildCount, 4, "sub" & SubCount, Mid(c, 2, InStr(2, c, ":") - 2), Mid(c, 2, InStr(2, c, ":") - 2)
                        ScriptMembers.Add Mid(c, InStr(2, c, ":") + 1), "sub" & SubCount
                        Case "3"
                        SubChildCount = SubChildCount + 1
                        TV.Nodes.Add "sub" & SubCount, 4, "sbc" & SubChildCount, Mid(c, 2, InStr(2, c, ":") - 2), TV.Nodes("sub" & SubCount).text
                        ScriptMembers.Add Mid(c, InStr(2, c, ":") + 1), "sbc" & SubChildCount
                         End Select
                         Loop
                         Close #t2
                        
                    Case Else 'Most Others
 
                        TV.Nodes.Add "sec" & SecondCount, 4, "chd" & ChildCount, Mid(a, 2, InStr(2, a, ":") - 2), TV.Nodes("sec" & SecondCount).text
                        ScriptMembers.Add Mid(a, InStr(2, a, ":") + 1), "chd" & ChildCount
                    
                End Select
                
        End If
        
        Loop
        
    Close #t

End Sub
